#include <conio.h>

#define CHARTIME 15000

int epci_stat;
extern int port;

int rcv_pkt(int pktlen, char *buf)	/* Returns -1 if error */
{
  register char *p;
  register int count;
  int timeout;				/* If this counts down to 0, time out */

	count = pktlen;
	p = buf;
	timeout=CHARTIME;
	do
	  { epci_stat = inp(port+1);	/* Copied from tstport() */
	    if (epci_stat & 0x30)	/* Communication error? */
	      { outp(port+3,0x15);	/* Reset chip */
	        return(-2);		/* Show error */
	      }
	    if (epci_stat & 2)		/* If character ready */
	      { *p++ = (unsigned)inp(port);	/* Code from NGET() */
	        count--;		/* Receive character & decr. count */
		timeout=CHARTIME;	/* Restart countdown timer */
	      }
	    else
	      timeout--;		/* Countdown timer */
	  }
	while (timeout>0 && count>0);
	return (timeout==0);		/* Return -1 if counted down to 0 */
}
